/// <reference types="react" />
import * as React from 'react';
import * as data from '../data';
export interface IFormBuilderProps {
    fields: data.IField[];
    registry: data.FieldRegistry;
    onChange: (fields: data.IField[], change: data.IFieldChange) => void;
    onError?: (error: {
        [id: string]: any;
    }) => void;
    onFieldEditing: (field: data.IField) => void;
    onBeforeAddField?: (field: data.IField) => boolean;
    onBeforeDeleteField?: (field: data.IField) => boolean;
    onBeforeEditField?: (field: data.IField) => boolean;
    editButton?: data.IEditableControlSource;
    deleteButton?: data.IEditableControlSource;
    idGenerator?: data.FormBuilderIDGenerator;
    canDrag?: (field: data.IField) => boolean;
    canDrop?: (source: data.IDragSourceItem, target: data.IDropTargetItem) => boolean;
    editingFieldId: string;
    parentId?: string;
    emptyLayout?: React.ReactNode;
}
export declare class FormBuilder extends React.Component<IFormBuilderProps, {}> {
    private builderError;
    constructor(props: IFormBuilderProps);
    addField(field: data.IField): void;
    private onEditField(field);
    private onDeleteField(index);
    private onDrop(target, source, didDrop);
    private ensureID(field);
    private onFieldChanged(field, index, change);
    private onFieldError(field, index, error);
    private canDrop(source, target);
    private renderField(field, index);
    render(): JSX.Element;
}
