"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var data = require("../data");
var react_dnd_1 = require("react-dnd");
// FormBuilderDraggable wraps a field in a draggable DOM node. When the user starts
// dragging this field, it will send the index and field to the drag and drop context
// that can be consumed by a drop target.
var FormBuilderDraggableComponent = (function (_super) {
    __extends(FormBuilderDraggableComponent, _super);
    function FormBuilderDraggableComponent() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FormBuilderDraggableComponent.prototype.render = function () {
        var connectDragSource = this.props.connectDragSource;
        return connectDragSource(React.createElement("div", null, this.props.children));
    };
    return FormBuilderDraggableComponent;
}(React.Component));
var spec = {
    canDrag: function (props, monitor) {
        if (props.canDrag) {
            return props.canDrag(props.field);
        }
        return true;
    },
    beginDrag: function (props) {
        return {
            index: props.index,
            field: props.field,
            parentId: props.parentId,
        };
    }
};
var collect = function (connect, monitor) {
    return {
        connectDragSource: connect.dragSource(),
    };
};
exports.FormBuilderDraggable = react_dnd_1.DragSource(data.FORM_BUILDER_FIELD, spec, collect)(FormBuilderDraggableComponent);
